﻿var customText = "txtCustom", customDynamicDropdown = "ddlDynSelect", customStaticDropdown = "ddlStcSelect", errorContainer = "divErrorMessage";
(function () {
    if (typeof SPClientTemplates === 'undefined')
        return;

    var siteCtx = {};

    siteCtx.Templates = {};

    siteCtx.Templates.Fields = {
        //MyCustomField is the Name of our field
        'MyCustomField': {
            'View': customView,
            'DisplayForm': customDisplayForm,
            'EditForm': customNew,
            'NewForm': customEdit
        },
        "MyComplexField": {
            'View': customComplexView,
            'DisplayForm': customComplexView,
            'EditForm': customComplexNewOrEdit,
            'NewForm': customComplexNewOrEdit
        }
    };

    //register the template to render custom field
    SPClientTemplates.TemplateManager.RegisterTemplateOverrides(siteCtx);
})();

//View Page custom rendering 
function customView(ctx) {
    var currentVal = '';
    //from the context get the current item and it's value
    if (ctx != null && ctx.CurrentItem != null) {

        //Access current field value
        //currentVal = ctx.CurrentItem[ctx.CurrentFieldSchema.Name];

        var percentCompete = parseInt(ctx.CurrentItem.PercentComplete);
        if (percentCompete != 100) {
            return "<span style='color:red'>Incomplete Task</span>";
        }
        else {
            return "<span style='color:green'>Task Completed</span>";
        }
    }
}

//Display Page custom rendering
function customDisplayForm(ctx) {
    if (ctx == null || ctx.CurrentFieldValue == null)
        return '';

    //render view
}

function customNew(ctx) {
    if (ctx == null || ctx.CurrentFieldValue == null)
        return '';

    var formCtx = SPClientTemplates.Utility.GetFormContextForCurrentField(ctx);
    if (formCtx == null || formCtx.fieldSchema == null)
        return '';
}

function customEdit(ctx) {
    if (ctx == null || ctx.CurrentFieldValue == null)
        return '';

    var formCtx = SPClientTemplates.Utility.GetFormContextForCurrentField(ctx);
    if (formCtx == null || formCtx.fieldSchema == null)
        return '';
}

/**************** Complex Field START ****************************/
function customComplexView(ctx) {
    return getCustomFieldValue(ctx);
}

function customComplexNewOrEdit(ctx) {
    if (ctx == null || ctx.CurrentFieldValue == null)
        return '';

    var formCtx = SPClientTemplates.Utility.GetFormContextForCurrentField(ctx);
    if (formCtx == null || formCtx.fieldSchema == null)
        return '';

    formCtx.registerGetValueCallback(formCtx.fieldName, function () {
        // Read value from this callback and assign to the field before save.
        var data = "(text:" + $("#" + customText).val() + ")(dynDdl:" + $("#" + customDynamicDropdown).val() + ")(staticDdl:" + $("#" + customStaticDropdown).val() + ")";
        //alert(data);
        return data;
    });

    //Create container for validators
    var validatorContainer = new SPClientForms.ClientValidation.ValidatorSet();

    //Handler Required Validation if specified
    if (formCtx.fieldSchema.Required) {
        //Register Required Field Validator
        validatorContainer.RegisterValidator(new SPClientForms.ClientValidation.RequiredValidator());
    }

    //Register validator for the field if exists
    if (validatorContainer._registeredValidators.length > 0) {
        formCtx.registerClientValidator(formCtx.fieldName, validatorContainer);
    }

    // Handler Callback if any error occurs due to validation
    formCtx.registerValidationErrorCallback(formCtx.fieldName, function (errorResult) {
        //Append Error message to specific element.
        SPFormControl_AppendValidationErrorMessage(errorContainer, errorResult);
    });

    var existingValue = getCustomFieldValue(ctx);
    var tempText = getCustomFieldPartValue("text", existingValue);
    var staticDdlValue = getCustomFieldPartValue("staticDdl", existingValue);

    //Render Input Fields
    var inputFields = "<table>";
    inputFields += "<tr><td>Custom Text</td><td>Dynamic Dropdown</td><td>Static Dropdown</td><td></td></tr>";
    inputFields += "<tr><td>";
    inputFields += "<input type='text' id='" + customText + "' value='" + tempText + "' /></td>";
    inputFields += "<td><select id='" + customDynamicDropdown + "'></select></td>";
    inputFields += "<td><select id='" + customStaticDropdown + "'>";
    inputFields += "<option value='1' " + (staticDdlValue == "1" ? "selected='selected'" : "") + ">Custom One</option>";
    inputFields += "<option value='2' " + (staticDdlValue == "2" ? "selected='selected'" : "") + ">Custom Two</option>";
    inputFields += "<option value='3' " + (staticDdlValue == "3" ? "selected='selected'" : "") + ">Custom Three</option>";
    inputFields += "</select></td></tr></table><div id='" + errorContainer + "'></div>";


    // Get List data from REST API
    $.ajax({
        url: _spPageContextInfo.webAbsoluteUrl + "/_api/web/lists/getbytitle('MasterList')/items?$select=Title,ID",
        method: "GET",
        headers: { "Accept": "application/json; odata=verbose" },
        success: function (data) {
            var html = "";
            var existingSelected = getCustomFieldPartValue("dynDdl", existingValue);
            for (var i = 0; i < data.d.results.length; i++) {
                if (existingSelected.length > 0 && existingSelected == data.d.results[i].ID) {
                    html += "<option value='" + data.d.results[i].ID + "' selected='selected'>" + data.d.results[i].Title + "</option>";
                }
                else {
                    html += "<option value='" + data.d.results[i].ID + "'>" + data.d.results[i].Title + "</option>";
                }
            }

            //Add options to the dynamic dropdown list
            $("#" + customDynamicDropdown).append(html);
        },
        error: function (data) {
            alert(JSON.stringify(data));
        }
    });


    return inputFields;

}

function getCustomFieldValue(ctx) {
    var val = '';
    if (ctx != null && ctx.CurrentItem != null)
        val = ctx.CurrentItem[ctx.CurrentFieldSchema.Name];

    return val;
}

function getCustomFieldPartValue(fieldName, rawValue) {
    var defineField = "(" + fieldName + ":";
    var fieldLength = defineField.length;
    var startIndex = rawValue.indexOf(defineField);

    if (0 <= startIndex) {
        var lastIndex = rawValue.indexOf(')', startIndex + fieldLength);
        return rawValue.substring(startIndex + defineField.length, lastIndex);
    }

    return '';
}

// Get Text of selected Id
function getDropdownSelectedText(elementId) {
    var ele = document.getElementById(elementId);

    if (ele.selectedIndex == -1)
        return null;

    return ele.options[ele.selectedIndex].text;
}
/**************** Complex Field END ****************************/